#!/bin/bash

# using this instead of "rpm -Uvh" to resolve dependencies
function rpm_install() {
  package=$(echo $1 | awk -F "/" '{print $NF}')
  wget --quiet $1
  yum install -y ./$package
  rm -f $package
}

release=$(awk -F \: '{print $5}' /etc/system-release-cpe)

rpm --import http://download-ib01.fedoraproject.org/pub/epel/RPM-GPG-KEY-EPEL-${release}
rpm --import http://yum.puppetlabs.com/RPM-GPG-KEY-puppet
rpm --import http://vault.centos.org/RPM-GPG-KEY-CentOS-${release}

yum install -y wget

# install and configure puppet
rpm -qa | grep -q puppet
if [ $? -ne 0 ]
then
  rpm_install http://yum.puppetlabs.com/puppet6/puppet6-release-el-${release}.noarch.rpm
  yum -y install puppet-agent
  ln -s /opt/puppetlabs/puppet/bin/puppet /usr/bin/puppet
fi

# use local pam module
puppet resource file /etc/puppetlabs/code/environments/production/modules/pam ensure=link target=/vagrant

# setup module dependencies
puppet module install puppetlabs/stdlib --version 4.25.0
puppet module install trlinkin/nsswitch --version 2.1.0
